---
title: XRSession.updateRenderState()
slug: Web/API/XRSession/updateRenderState
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Method
  - Reference
  - Update
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XR
  - XRSession
  - render
  - state
  - updateRenderState()
---
<div>{{draft}}{{securecontext_header}}{{APIRef("WebXR Device API")}}</div>

<p><span class="seoSummary">The <code>updateRenderState()</code> method of the {{DOMxRef("XRSession")}} interface of <a href="/en-US/docs/Web/API/WebXR_API">WebXR API</a> schedules changes to be applied to the active render state prior to rendering of the next frame.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>xrSession</em>.updateRenderState(<em>newState</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>newState</code></dt>
 <dd>An object conforming to the {{domxref("XRRenderStateInit")}} dictionary specifying the properties of the session's {{domxref("XRSession.renderState", "renderState")}} to update before rendering the next frame.</dd>
</dl>

<p>The specified object may have any combination of the following fields.</p>

<p>{{page("/en-US/docs/Web/API/XRRenderStateInit","Properties")}}</p>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may throw any of the following exceptions. These are true exceptions, since this method does not return a promise.</p>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>
 <p>This may occur for one of the following reasons:</p>

 <ul>
  <li>The {{domxref("XRSession")}} has already ended, so you cannot change its render state.</li>
  <li>The {{domxref("XRRenderStateInit.baseLayer", "baseLayer")}} specified in <code>newState</code> was created by an <code>XRSession</code> other than the one on which <code>updateRenderState()</code> was called.</li>
  <li>The {{domxref("XRRenderStateInit.inlineVerticalFieldOfView", "inlineVerticalFieldOfView")}} property was set, but the session is immersive and therefore does not allow this property to be used.</li>
 </ul>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This example creates a WebGL context that is compatible with an immersive XR device and then uses it to create an {{DOMxRef("XRWebGLLayer")}}. <code>updateRenderState()</code> is then called to associate the new <code>XRWebGLLayer</code>.</p>

<pre class="brush: js">function onXRSessionStarted(xrSession) {
  let glCanvas = document.createElement("canvas");
  let gl = glCanvas.getContext("webgl", { xrCompatible: true });

  loadWebGLResources();

  xrSession.updateRenderState({ baseLayer: new XRWebGLLayer(xrSession, gl) });
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrsession-updaterenderstate","XRSession.updateRenderState()")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSession.updateRenderState")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li>{{domxref("XRRenderState")}}</li>
 <li>{{domxref("XRSession.renderState")}} </li>
</ul>
